int sw = 0;

#include <Arduino.h>
#define RED_GPIO       42
#define YELLOW_GPIO    41
#define GREEN_GPIO     40
#define PIR_PIN        13

//OLED

#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#include <Fonts/FreeSerif9pt7b.h>

#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 64 // OLED display height, in pixels

// Declaration for an SSD1306 display connected to I2C (SDA, SCL pins)
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, -1);
int pir_state;




//MQTT config
#include <WiFi.h>
#include <PubSubClient.h>

#define WIFI_SSID    "KUWIN-IOT"
#define WIFI_PASS    ""
#define MQTT_BROKER  "iot.cpe.ku.ac.th"
#define MQTT_USER    "b6510503247"
#define MQTT_PASS    "kanathip.p@ku.th"
#define TOPIC_PREFIX "b6510503247"

//MQTT

#define TOPIC_TOGGLE "b6510503247/toggle"
#define TOPIC_UNIT "b6510503247/unit"
#define TOPIC_STACK   "b6510503247/stack"
#define TOPIC_SWITCH   "b6510503247/switch"
#define TOPIC_SWITCHD   "b6510503247/switchd"

WiFiClient wifiClient;
PubSubClient mqtt(MQTT_BROKER, 1883, wifiClient);
uint32_t last_publish;
uint32_t last_publish2;
uint32_t last_publish3;


void connect_wifi() {
  printf("WiFi MAC address is %s\n", WiFi.macAddress().c_str());
  printf("Connecting to WiFi %s.\n", WIFI_SSID);
  WiFi.mode(WIFI_STA);
  WiFi.begin(WIFI_SSID, WIFI_PASS);
  while (WiFi.status() != WL_CONNECTED) {
    printf(".");
    fflush(stdout);
    delay(500);
  }
  printf("\nWiFi connected.\n");
}

void connect_mqtt() {
  printf("Connecting to MQTT broker at %s.\n", MQTT_BROKER);
  if (!mqtt.connect("", MQTT_USER, MQTT_PASS)) {
    printf("Failed to connect to MQTT broker.\n");
    for (;;) {} // wait here forever
  }
  mqtt.setCallback(mqtt_callback);
  mqtt.subscribe(TOPIC_TOGGLE);
  mqtt.subscribe(TOPIC_STACK);
  mqtt.subscribe(TOPIC_SWITCH);
  printf("MQTT broker connected.\n");
}

void mqtt_callback(char* topic, byte* payload, unsigned int length) {
  if (strcmp(topic, TOPIC_TOGGLE) == 0) {
    payload[length] = 0; // null-terminate the payload to treat it as a string
    int value = atoi((char*)payload); 
    if (value == 0) {
      digitalWrite(RED_GPIO, LOW);
    }
    else if (value == 1) {
      digitalWrite(RED_GPIO, HIGH);
    }
    else {
      printf("Invalid payload received.\n");
    }
  }
}
int stack = 0;

void setup() {
  pinMode(RED_GPIO, OUTPUT);
  pinMode(YELLOW_GPIO, OUTPUT);
  pinMode(GREEN_GPIO, OUTPUT);
  pinMode(PIR_PIN, INPUT);
  digitalWrite(RED_GPIO, 0);
  digitalWrite(YELLOW_GPIO, 0);
  digitalWrite(GREEN_GPIO, 0);
  Serial.begin(115200);

  // oled diplay
  Wire.begin(48,47);
  if(!display.begin(SSD1306_SWITCHCAPVCC, 0x3C)) { 
    Serial.println("SSD1306 allocation failed");
    for(;;);
  
  }  
delay(2000);
  display.setFont(&FreeSerif9pt7b);
  display.clearDisplay();
  display.setTextSize(1);             
  display.setTextColor(WHITE);        
  display.setCursor(0,20);             
  display.println("Loading...");
  display.display();
  delay(2000);
  // MQTT setup

  connect_wifi();
  connect_mqtt();
  last_publish = 0;
  last_publish2 = 0;
  last_publish3 = 0;

}

double sec;
bool debounce = false;
void loop() {
  pir_state = digitalRead(PIR_PIN);
  Serial.print("PIR state:");
  Serial.println(pir_state);
  Serial.print("////");
  Serial.print("Stack:");
  Serial.println(stack);

// oled diplay

  display.clearDisplay();
  display.setTextSize(1);             
  display.setTextColor(WHITE);        
  display.setCursor(0,20);             
  display.println("Stack Level :");
  display.setCursor(110,20);             
  display.println(stack);
  display.setCursor(0,48);
  display.println("PIR State:");   
  display.setCursor(110,48);
  display.println(pir_state);   
  display.display();
 int sw_copy = sw;
  if (pir_state == LOW && stack <= 50) {
    stack += 50;
    Serial.println("Motion detected!");
  }
  if (stack > 0) {
    stack -= 1;
    if (digitalRead(RED_GPIO) == HIGH){
    sec += 0.1;
    sw = 1;
    }
    else {
      sw = 0;
    }
  }
  else{
    sw = 0;
    }
  
  delay(100);

  //MQTT

  mqtt.loop();

  uint32_t now = millis();
  if (now - last_publish >= 1000) {
    int level = stack;
    String payload(level);
    printf("Publishing stack value: %d\n", level);
    mqtt.publish(TOPIC_STACK, payload.c_str());
    last_publish = now;
  }
  uint32_t now2 = millis();
  if (now2 - last_publish2 >= 1000) {
    int state = sw;
    String payload(state);
    printf("Publishing state value: %d\n", state);
    mqtt.publish(TOPIC_SWITCH, payload.c_str());
    last_publish2 = now2;
  }
  uint32_t now3 = millis();
  if (now3 - last_publish3 >= 1000) {
    double unit = (sec*9)/(60 * 60);
    String payload(unit);
    printf("Publishing unit value: %f\n", unit);
    mqtt.publish(TOPIC_UNIT, payload.c_str());
    last_publish3 = now3;
  }
  if (sw != sw_copy) {
    int state = sw;
    String payload(state);
    printf("Publishing delayed value: %d\n", state);
    mqtt.publish(TOPIC_SWITCHD, payload.c_str());

  }
}