// Relay
#define RELAY_PIN  14 // Change this to the pin connected to the relay

// MQTT
#include <PubSubClient.h>
#include <WiFi.h>


#define WIFI_SSID    "KUWIN-IOT"
#define WIFI_PASS    ""
#define MQTT_BROKER  "iot.cpe.ku.ac.th"
#define MQTT_USER    "b6510503247"
#define MQTT_PASS    "kanathip.p@ku.th"
#define TOPIC_PREFIX "b6510503247"

#define TOPIC_TOGGLE    TOPIC_PREFIX "/toggle"
#define TOPIC_SWICH    TOPIC_PREFIX "/switch"

WiFiClient wifiClient;
PubSubClient mqtt(MQTT_BROKER, 1883, wifiClient);
uint32_t last_publish;

void connect_wifi() {
  printf("WiFi MAC address is %s\n", WiFi.macAddress().c_str());
  printf("Connecting to WiFi %s.\n", WIFI_SSID);
  WiFi.mode(WIFI_STA);
  WiFi.begin(WIFI_SSID, WIFI_PASS);
  while (WiFi.status() != WL_CONNECTED) {
    printf(".");
    fflush(stdout);
    delay(500);
  }
  printf("\nWiFi connected.\n");
}

void connect_mqtt() {
  printf("Connecting to MQTT broker at %s.\n", MQTT_BROKER);
  if (!mqtt.connect("", MQTT_USER, MQTT_PASS)) {
    printf("Failed to connect to MQTT broker.\n");
    for (;;) {} // wait here forever
  }
  mqtt.setCallback(mqtt_callback);
  mqtt.subscribe(TOPIC_SWICH);
  mqtt.subscribe(TOPIC_TOGGLE);
  printf("MQTT broker connected.\n");
}

int sec;
int toggle;
void mqtt_callback(char* topic, byte* payload, unsigned int length) {
  if (strcmp(topic, TOPIC_TOGGLE) == 0) {
    payload[length] = 0; // null-terminate the payload to treat it as a string
    int value = atoi((char*)payload); 
    if (value == 0 ) {
    toggle = 0;
  delay(100);
    }
    else if (value == 1 ) {
  toggle = 1;
  delay(100);
    }
    else {
      printf("Invalid payload toggle received.\n");
    }
  }
  if (strcmp(topic, TOPIC_SWICH) == 0) {
    payload[length] = 0; // null-terminate the payload to treat it as a string
    int value = atoi((char*)payload); 
    if (value == 0 || toggle == 0) {
  digitalWrite(RELAY_PIN, LOW);
  Serial.println("Relay is off");
  delay(100);
    }
    else if (value == 1 && toggle == 1) {
  digitalWrite(RELAY_PIN, HIGH);
  Serial.println("Relay is on");
  delay(100);
    }
    else {
      printf("Invalid payload received.\n");
    }
  }
  
}

void setup() {

  // relay
  pinMode(RELAY_PIN, OUTPUT);
  //mqtt
    connect_wifi();
  connect_mqtt();
  Serial.begin(115200);
}

void loop() {
  mqtt.loop();
}

